#define initialize_sums(WORKSIZE)										\
	float sum[WORKSIZE];												\
    if (WORKSIZE >= 1) sum[0] = 0.0;									\
	if (WORKSIZE >= 2) sum[1] = 0.0;									\
	if (WORKSIZE >= 3) sum[2] = 0.0;									\
	if (WORKSIZE >= 4) sum[3] = 0.0;									\
	if (WORKSIZE >= 5) sum[4] = 0.0;									\
	if (WORKSIZE >= 6) sum[5] = 0.0;									\
	if (WORKSIZE >= 7) sum[6] = 0.0;									\
	if (WORKSIZE >= 8) sum[7] = 0.0;									\
	if (WORKSIZE >= 16) sum[8] = sum[9] = sum[10] = sum[11] = sum[12] = sum[13] = sum[14] = sum[15] = 0.0;

#define add_to_sums(WORKSIZE, BLOCKSIZE)						   \
	if (WORKSIZE >= 1) sum[0] += A[0] * B_s[k];					   \
	if (WORKSIZE >= 2) sum[1] += A[0] * B_s[k + BLOCKSIZE];		   \
	if (WORKSIZE >= 3) sum[2] += A[0] * B_s[k + 2 * BLOCKSIZE];	   \
	if (WORKSIZE >= 4) sum[3] += A[0] * B_s[k + 3 * BLOCKSIZE];	   \
	if (WORKSIZE >= 5) sum[4] += A[0] * B_s[k + 4 * BLOCKSIZE];	   \
	if (WORKSIZE >= 6) sum[5] += A[0] * B_s[k + 5 * BLOCKSIZE];	   \
	if (WORKSIZE >= 7) sum[6] += A[0] * B_s[k + 6 * BLOCKSIZE];	   \
	if (WORKSIZE >= 8) sum[7] += A[0] * B_s[k + 7 * BLOCKSIZE];	   \
	if (WORKSIZE >= 16)											   \
	{															   \
		sum[8] += A[0] * B_s[k + 8 * BLOCKSIZE];				   \
		sum[9] += A[0] * B_s[k + 9 * BLOCKSIZE];				   \
		sum[10] += A[0] * B_s[k + 10 * BLOCKSIZE];				   \
		sum[11] += A[0] * B_s[k + 11 * BLOCKSIZE];				   \
		sum[12] += A[0] * B_s[k + 12 * BLOCKSIZE];				   \
		sum[13] += A[0] * B_s[k + 13 * BLOCKSIZE];				   \
		sum[14] += A[0] * B_s[k + 14 * BLOCKSIZE];				   \
		sum[15] += A[0] * B_s[k + 15 * BLOCKSIZE];				   \
	}

#define sub_to_sums(WORKSIZE, BLOCKSIZE)						   \
	if (WORKSIZE >= 1) sum[0] -= A[0] * B_s[k];					   \
	if (WORKSIZE >= 2) sum[1] -= A[0] * B_s[k + BLOCKSIZE];		   \
	if (WORKSIZE >= 3) sum[2] -= A[0] * B_s[k + 2 * BLOCKSIZE];	   \
	if (WORKSIZE >= 4) sum[3] -= A[0] * B_s[k + 3 * BLOCKSIZE];	   \
	if (WORKSIZE >= 5) sum[4] -= A[0] * B_s[k + 4 * BLOCKSIZE];	   \
	if (WORKSIZE >= 6) sum[5] -= A[0] * B_s[k + 5 * BLOCKSIZE];	   \
	if (WORKSIZE >= 7) sum[6] -= A[0] * B_s[k + 6 * BLOCKSIZE];	   \
	if (WORKSIZE >= 8) sum[7] -= A[0] * B_s[k + 7 * BLOCKSIZE];	   \
	if (WORKSIZE >= 16)											   \
	{															   \
		sum[8] -= A[0] * B_s[k + 8 * BLOCKSIZE];				   \
		sum[9] -= A[0] * B_s[k + 9 * BLOCKSIZE];				   \
		sum[10] -= A[0] * B_s[k + 10 * BLOCKSIZE];				   \
		sum[11] -= A[0] * B_s[k + 11 * BLOCKSIZE];				   \
		sum[12] -= A[0] * B_s[k + 12 * BLOCKSIZE];				   \
		sum[13] -= A[0] * B_s[k + 13 * BLOCKSIZE];				   \
		sum[14] -= A[0] * B_s[k + 14 * BLOCKSIZE];				   \
		sum[15] -= A[0] * B_s[k + 15 * BLOCKSIZE];				   \
	}

#define write_sums(WORKSIZE, BLOCKSIZE)									\
	if (WORKSIZE >= 1) C[0 * BLOCKSIZE] = sum[0];						\
	if (WORKSIZE >= 2) C[1 * BLOCKSIZE] = sum[1];						\
	if (WORKSIZE >= 3) C[2 * BLOCKSIZE] = sum[2];						\
	if (WORKSIZE >= 4) C[3 * BLOCKSIZE] = sum[3];						\
	if (WORKSIZE >= 5) C[4 * BLOCKSIZE] = sum[4];						\
	if (WORKSIZE >= 6) C[5 * BLOCKSIZE] = sum[5];						\
	if (WORKSIZE >= 7) C[6 * BLOCKSIZE] = sum[6];						\
	if (WORKSIZE >= 8) C[7 * BLOCKSIZE] = sum[7];						\
	if (WORKSIZE >= 16)													\
	{																	\
		C[8 * BLOCKSIZE] = sum[8];										\
		C[9 * BLOCKSIZE] = sum[9];										\
		C[10 * BLOCKSIZE] = sum[10];									\
		C[11 * BLOCKSIZE] = sum[11];									\
		C[12 * BLOCKSIZE] = sum[12];									\
		C[13 * BLOCKSIZE] = sum[13];									\
		C[14 * BLOCKSIZE] = sum[14];									\
		C[15 * BLOCKSIZE] = sum[15];									\
	}

#define add_to_sums_check_bounds(row, mrest, BLOCKSIZE, WORKSIZE)		\
	if (WORKSIZE >= 1) sum[0] += A[0] * B_s[k];							\
	if (WORKSIZE >= 2 && row + BLOCKSIZE < mrest) sum[1] += A[BLOCKSIZE] * B_s[k]; \
	if (WORKSIZE >= 3 && row + 2 * BLOCKSIZE < mrest) sum[2] += A[2 * BLOCKSIZE] * B_s[k]; \
	if (WORKSIZE >= 4 && row + 3 * BLOCKSIZE < mrest) sum[3] += A[3 * BLOCKSIZE] * B_s[k]; \
	if (WORKSIZE >= 5 && row + 4 * BLOCKSIZE < mrest) sum[4] += A[4 * BLOCKSIZE] * B_s[k]; \
	if (WORKSIZE >= 6 && row + 5 * BLOCKSIZE < mrest) sum[5] += A[5 * BLOCKSIZE] * B_s[k]; \
	if (WORKSIZE >= 7 && row + 6 * BLOCKSIZE < mrest) sum[6] += A[6 * BLOCKSIZE] * B_s[k]; \
	if (WORKSIZE >= 8 && row + 7 * BLOCKSIZE < mrest) sum[7] += A[7 * BLOCKSIZE] * B_s[k];

